function x = logfactorial(x)
% # Logarithm of the factorial function
% ## Usage
% * `y = logfactorial(x)`
% 
% ## Description
% Calculates the logarithm of the factoril, that is,
%
%     y = log(1*2*...*x) = log(1) + log(2) + ... + log(x)
%
% ## Input
% * `x`: Input to the factorial function.
%
% ## Outut
% * `y`: Log-factorial of `x`.
%
% ## Authors
% 2019-present -- Roland Hostettler

%{
% This file is free software: you can redistribute it and/or modify it 
% under the terms of the GNU General Public License as published by the 
% Free Software Foundation, either version 3 of the License, or (at your
% option) any later version.
% 
% This file is distributed in the hope that it will be useful, but WITHOUT
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
% FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
% more details.
% 
% You should have received a copy of the GNU General Public License along 
% with this file. If not, see <http://www.gnu.org/licenses/>.
%}

    narginchk(1, 1);
    xmax = max(x(:));
    logy = cumsum(log([1 1:xmax]));
    x(:) = logy(x+1);
end
